
  *=$1000

; X,Y -> Popped pixel coordinates

; 80    -> Temporary used to save/restore Y
; 82,83 -> Screen address for the current byte / Stored X,Y coordinates
; 8C    -> Initialized to zero
; 8D,8E -> Set to 1 when 8C is zero
; 8F    -> Used to store the Stack pointer / Result of the pixel check

; Called when the assembler is loaded
_Paint
	/*RTS ;*/ SEI

	LDX #$0F
loop_save_80	
	LDA $80,X
	STA zero_page_80,X     ; $10E2
	DEX 
	BPL loop_save_80  ; $1003 

	CLD 
	JSR _TableGenerate  ; $1200    ; Create the 1K graphics table from $1400 to $17FF
	LDX $00 
	LDY $01 

	LDA #$00 
	STA $8C

	; Push an end marker on the stack
	LDA #$FF 
	PHA 
	PHA 
	BNE check_x  ; $1021 

big_loop
	; Pull next values from the stack	
	PLA 
	TAY 
	PLA 
	TAX 

check_x	
	CPX #$FF 
	BEQ end_paint  ; $1084 

	LDA $8C 
	BNE label_102f  ; $102F 
	LDA #$01 
	STA $8D 
	STA $8E 
label_102f	
	JSR store_82_83_8f   ; $10A2 
	DEY 
	JSR pixel_check  ; $1098 

	; 1036
	STA $8F 
	BNE label_1042 ; $1042 
	LDA $8D 
	BEQ label_1042 ; $1042 
	TXA 
	PHA 
	TYA 
	PHA 
label_1042	
	LDA $8F 
	STA $8D 
	INY 
	INY 
	JSR pixel_check  ; $1098 
	STA $8F 
	BNE label_1057   ; $1057 
	LDA $8E 
	BEQ label_1057   ; $1057 
	TXA 
	PHA 
	TYA 
	PHA 
label_1057	
	LDA $8F 
	STA $8E 
	DEY 
	DEX 
	JSR pixel_check  ; $1098
	BNE label_106C   ; $106C 
	TXA 
	PHA 
	TYA 
	PHA 
	LDA #$01 
	STA $8C
	BNE label_1070  ; $1070 

label_106C	
	LDA #$00 
	STA $8C 
label_1070	
	INX 
	INX 
	JSR pixel_check  ; $1098 
	BNE label_107F   ; $107F 
	TXA 
	PHA 
	TYA 
	PHA 
	LDA #$01 
	STA $8C 
label_107F	
	DEX 
	LDA #$00 
	BEQ big_loop   ;$101D 

end_paint  ; $1084
	LDX #$0F 
loop_restore_80	
	LDA zero_page_80,X  ; $10E2
	STA $80,X 
	DEX 
	BPL loop_restore_80 ; $1086 

	CLI 
	RTS 

draw_pixel   ; label_1090	
	STY $80 
	JSR _SetDot   ; $137E 
	LDY $80 
	RTS 

pixel_check   ;label_1098
	STY $80 
	JSR _TestDot  ; $1398 
	PHP 
	LDY $80 
	PLP
	RTS

store_82_83_8f  ; label_10a2
	STX $82
	STY $83
	TSX 
	STX $8F
	INX 
	INX 
	INX

label_10ac
	LDA $100,X 
	CMP #$FF 
	BEQ label_10d8  ; $10D8 
	CMP $83 
	BNE label_10d3  ; $10D3 

	LDA $101,X 
	CMP $82 
	BNE label_10d3  ; $10D3
	DEX
	CPX $8F 
	BEQ $10CC 

	LDA $100,X 
	STA $102,X
	SEC 
	BCS $10BE

label_10cc
	INC $8F 
	INC $8F
	SEC 
	BCS label_10d8   ; $10D8

label_10d3	
	INX 
	INX 
	SEC 
	BCS label_10ac ; $10AC

label_10d8	
	LDX $8F
	TXS 
	LDX $82
	LDY $83
	JMP draw_pixel  ; $1090

zero_page_80

 .dsb $1200-*
  ; *=$1200

_TableGenerate  
	LDX #$00 
	LDY #$00 
	STX $80
	TXA 
	ASL
	ASL
	ASL 
	ASL
	STA $1500,Y 
	LDA $80 
	STA $1400,Y
	INY 
	BEQ $1222
	INX 
	CPX #$06
	BNE $1206
	INC $80
	LDX #$00

	BEQ $1206 
	NOP 
	LDA #$A0
	STA $81 
	LDA #$00 
	TAY 
	STA $80 
	LDA $80 
	STA $1600,Y 
	LDA $81 
	STA $1700,Y 
	LDA $80 
	CLC 
	ADC #$28 
	STA $80 
	BCC $1240 
	INC $81 
	INY 
	BNE $122B 
	RTS

 .dsb $1360-*    ; Page 

_GetPixelAddress    ; 1360-137D
	CLS
	LDA $1600,Y
	ADC $1400,X
	STA $82
	LDA #$00
	ADC $1700,Y
	STA $83
	LDA $1500,X
	LSR
	LSR
	LSR
	LSR
	TAY
	LDA $139E,Y
	LDY #$00
	RTS


 .dsb $137E-*    ; Page 77

_SetDot    ; 137E-1385
	JSR $1360
	ORA ($82),Y
	STA ($82),Y
	RTS

_ClearDot  ; 1386-138F
	JSR $1360
	EOR #$FF
	AND ($82),Y
	STA ($82),Y
	RTS

_AlterDot  ; 1390-1397
	JSR $1360
	EOR ($82),Y
	STA ($82),Y
	RTS

_TestDot   ; 1398-139D
	JSR $1360
	AND ($82),Y
	RTS

_TableBits  ; 139E
	.byt $20,$10,$08,$04,$02,$01,$00

   *=$1400

_Table1400

   *=$1500

_Table1500

  *=$1600

_TableHiresAddrLow

  *=$1700

_TableHiresAddrHigh


